package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;


/** This class represents an array type. Arrays are anonymous types and
  ** have an element type. An array defines a scope including solely the
  ** instance variable length.           */

public class Arrays extends Types implements AnArray, Scope {
    
    
    private AType eltType;  // the element type
    
    
    public Arrays ( AType e ) {
        
        super("[]"+e.getIdentifier());
        eltType = e;
        
    }; // constructor
    
    
    public AType getEltType ( ) {...};     // AnArray -- element type
    
    
    // public boolean equals ( Object o ) ;   // AType, from Types
    
    
    public boolean compatibleWith ( AType t ) {...};  // AType -- same element type
    
    
    public AClass getSuperclass ( ) {...};    // Scope -- no superclass
    
    
    public ADeclaration find ( String id ) {...};  // Scope -- only length (predefined)
    
    
    public boolean alreadyDefined ( String id ) {...} // Scope -- nothing
    
    
    public void define ( ADeclaration dcl ) {...};  // Scope -- nothing
    
    
    public String toString ( ) {...};
    
    
} // Arrays