package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** body = { var-dcl ; } constr-dcl { method-dcl }   */

public class Body extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...
    
    
    public Body ( Scope c, TokenSet s ) {
        
        super(c,s);
        
    }; // constructor
    
    
    public void parse ( ) {
        
        VarDcl  aVarDcl;  // a variable declaration
        ConstrDcl aConstrDcl;  // the constructor declaration
        MethodDcl aMethodDcl;  // a method declaration
        
        while ( true ) {
            check(oneOf(VarDcl.STARTS,ConstrDcl.STARTS),...);
        if ( tokenIn(oneOf(stopSet,ConstrDcl.STARTS,MethodDcl.STARTS...)) ) break;
            aVarDcl = new VarDcl(scope,...);
            aVarDcl.parse();
            checkAndDefine(aVarDcl.getDecl());
            expect(SEMI,...);
        };
        aConstrDcl = new ConstrDcl(scope,...);
        aConstrDcl.parse();
        while ( true ) {
            check(oneOf(stopSet,MethodDcl.STARTS),...);
        if ( tokenIn(stopSet...) ) break;
            if ( tokenIn(MethodDcl.STARTS) ) {
                aMethodDcl = new MethodDcl(scope,...);
                aMethodDcl.parse();
            };
        };
        
    }; // parse
    
    
} // Body