package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;

import java.util.*;


/** This class represents the declaration of a class. A class has a superclass,
  ** a constructor, and a set of members that are declared within the class.  */


public class Classes extends Types implements AClass, AType, Scope {
    
    
    protected AClass                        superclass;  // the superclass
    protected AConstructor                  theConstructor; // the constructor
    protected SomeMap<String,ADeclaration>  members;  // the members (declarations) of the class
    
    
    public Classes ( String id, AClass s ) {
        
        super(id);
        superclass = s;
        theConstructor = null;
        members = new ...;
        
    }; // constructor
    
    
    public AClass getSuperclass ( ) {...};  // AClass/Scope -- the superclass
    
    
    public void setConstructor ( AConstructor c ) {...};  // AClass -- establish constructor
    
    
    public AConstructor getConstructor ( ) {...};  // AClass -- the constructor
    
    
    // public boolean equals ( Objkect o ) {...};  // AType -- from Types
    
    
    public boolean compatibleWith ( AType t ) {...};  // AType -- this := t; this is a superclass of t
    
    
    public ADeclaration find ( String id ) {  // Scope
        
        ADeclaration  result;
        
        result = members.get(id); // check local scope
        if ( result == null ) {      // if not defined
            if ( superclass != null ) {    // if superclass exists
                result = superclass.find(id);  // check superclass
            }
            else {
                result = global.find(id); // no superclass, check globals
            };
        };
        return result;
        
    }; // find
    
    
    public boolean alreadyDefined ( String id ) {...};  // Scope -- defined in class
    
    
    public void define ( ADeclaration dcl ) {...};  // Scope -- define in class
    
    
    public String toString ( ) {...};   
    
    
} // Classes
