package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;

import java.util.*;
import java.io.*;


/** This class represents the system definition --- primitives, predefined
  ** and defined classes.            */

public class Global implements Serializable, Scope {
    
    
    private SomeMap<String,ADeclaration> globals; // the global declarations
    
    
    private Global ( ) {...}; // constructor
    
    
    /** This method is a factory method to obtain the global symbol takle for the program.
      * It tries to load the file Classes.syt from the specified directory. If it cannot,
      * it creates a new global symbol table populating it with the predefined types,
      * classes and objects.
      * 
      * @param  directory  the directory to locate the global symbol table.            */
    
    public static Global getGlobal ( File  directory ) {
        
        ObjectInputStream stream;
        Global    global;
        
        try {
            stream = new ObjectInputStream(
                           new FileInputStream(new File(directory,"Classes.syt")));
            global = (Global) stream.readObject();
        }
        catch ( IOException e ) {
            global = new Global();
            global.define( new Primitives("int"));
                     :
        }
        catch ( ClassNotFoundException e ) {
            System.out.println("Global class file corrupted."+e);
            global = null;
        };
        return global;
        
    }; // getGlobal
    
    
    /** This method writes the global symbol table as the file Classes.syt in the
      * specified directory.
      * 
      * @param  directory  the directory to write the global symbol table to.
      *
      * @throws  IOException  unable to create global symbol table file         */
    
    public void write ( File  directory ) throws IOException {
        
        ObjectOutputStream stream;
        
        stream = new ObjectOutputStream(new FileOutputStream( new File(directory,"Classes.syt")));
        stream.writeObject(this);
        
    }; // write
    
    
    public AClass getSuperclass ( ) {...}; // getSuperClass - none
    
    
    public ADeclaration find ( String id ) {...}; // find
    
    
    public boolean alreadyDefined ( String id ) {...}; // alreadyDefined
    
    
    public void define ( ADeclaration dcl ) {...}; // define
    
    
    public String toString ( ) {...}; // toString
    
    
}; // Global
