package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;

import java.util.*;


/** This class represents the declaration of a method. Every method has a
  ** return type (null for procedure methods) and a parameter list. A method
  ** defines a new scope.             */

public class Methods extends Declarations implements AMethod, Scope {
    
    
    protected Scope                         theClass;  // the scope (class) in which this method is nested
    protected AType                         result;   // the result type
    protected Parameters                    paramList;  // the parameter list
    protected SomeMap<String,ADeclaration>  locals;   // the local declarations
    
    
    public Methods ( String id, Scope c, AType r, Parameters p ) {
        
        super(id);
        theClass = c;
        result = r;
        paramList = p;
        locals = new ...;
        
    }; // constructor
    
    
    public boolean isFunction ( ) {...};    // AMethod -- is a function
    
    
    public boolean isProcedure ( ) {...};   // AMethod -- is a procedure
    
    
    public AType getResult ( ) {...};    // AMethod -- result type
    
    
    public Parameters getParamList ( ) {...};  // AMethod -- parameter list
    
    
    public boolean sigMatch ( AMethod meth ) {...};  // AMethod -- signatures match
   
    
    public AClass getSuperclass ( ) {...};     // Scope -- superclass of this method's class
    
    
    public ADeclaration find ( String id ) {...};   // Scope -- locals+params then class
    
    
    public boolean alreadyDefined ( String id ) {...};  // Scope -- in locals+params
    
    
    public void define ( ADeclaration dcl ) {...};   // Scope -- as a local
    
    
    public String toString ( ) {...};
    
    
} // Methods