package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** name      = qualifier [ . identifier ]         */

public class Name extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...
    
    
    private ADeclaration declaration; // declaration of the name
    
    
    public Name ( Scope c, TokenSet s ) {
        
        super(c,s);
        declaration = null;
        
    }; // constructor
    
    
    public ADeclaration getDecl ( ) {
        
        return declaration;
        
    }; // getDeclaration
    
    
    public void parse ( ) {
        
        Qualifier  aQualifier;  // qualifier
        String   name;
        Scope   newScope;
        
        aQualifier = new Qualifier(scope,...);
        aQualifier.parse();
        check(oneOf(stopSet,DOT),...);
        if ( tokenIs(DOT) ) { // qualified
               :
            newScope = ... based on qualifier...;
            accept();
            name = expectId("Unexpected symbol",...);
            declaration = findDcl(name,newScope);
        }
        else { // not qualified
            declaration = aQualifier.getDeclaration();
        };
        
    }; // parse
    
    
} // Name