package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;


/** This interface represents units the provide scoping (i.e. classes,
  ** constructors and methods).            */

public interface Scope {
    
    
    /** This method returns the superclass within this scope.
      **
      ** @return AClass the superclass          */
    
    public AClass getSuperclass ( );
    
    
    /** This method locates the declaration of the identifier in the local
      ** or encompassing scope.
      **
      ** @param id the id to search for
      **
      ** @return Declaration the declaration found or null if not found  */
    
    public ADeclaration find ( String id );
    
    
    /** This method determines if the identifier is defined in the local
      ** scope.
      **
      ** @param id the id to search for
      **
      ** @return boolean true if the identifier is already defined   */
    
    public boolean alreadyDefined ( String id );
    
    
    /** This method adds the declaration to the local scope.
      **
      ** @param dcl the declaration to add         */
    
    public void define ( ADeclaration dcl );
    
    
}; // Scope
