package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents a generic syntactic unit. It provides standard methods
  ** in support of parsing, semantic analysis and code generation. Every syntactic
  ** unit has a scope and a set of stop tokens for parsing.      */

public abstract class SyntacticUnit {
    
    
    protected Scope   scope;
    protected TokenSet  stopSet;
    
    
    protected SyntacticUnit ( Scope c, TokenSet s ) {...}; // constructor
    
    
    public abstract void parse ( ) ;
    
             :
             :
    
    
// Semantic Analysis helper methods - Kind checking
    
    protected AClass asClassDcl ( ADeclaration dcl ) {
        
        if ( dcl instanceof AClass ) {
            return (AClass) dcl;
        }
        else {
            semanticError("Wrong kind for identifier");
            return universalDcl;
        }
        
    }; // asClassDcl
    
             :
             :
    
    
} // SyntacticUnit