package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents a generic syntactic unit. It provides standard methods
  ** in support of parsing, semantic analysis and code generation. Every syntactic
  ** unit has a scope and a set of stop tokens for parsing.      */

public abstract class SyntacticUnit {
    
    
    protected Scope   scope;
    protected TokenSet  stopSet;
    
    
    protected SyntacticUnit ( Scope c, TokenSet s ) {...}; // constructor
    
    
    public abstract void parse ( ) ;
    
    
// Syntactic Analysis Helper Methods
    
        :
        :
    
// Semantic Analysis helper methods -- Scope checking
    
        :
        :    
    
// Semantic Analysis helper methods - Kind checking
    
        :
        :    
    
// Semantic Analysis helper methods - Type checking
    
    protected AType expectTypeId ( String errMsg, TokenSet context ) {
        
        ADeclaration dcl;
        AType    type;
        String   name;
        
        type = null;
        if ( tokenIs(IDENTIFIER) ) {
            name = source.getCurToken().getSource();
            dcl = findDcl(name,scope);
            type = asTypeDcl(dcl);
        }
        else {
            name = missingName;
            type = universalDcl;
        };
        expect(IDENTIFIER,errMsg,context);
        return type;
        
    }; // expectTypeId
    
    
} // SyntacticUnit