package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** term = factor { multiplying-op  factor }       */

public class Term extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...;
    
    
    private AType   result;  // result type
    
    
    public Term ( Scope c, TokenSet s ) {
        
        super(c,s);
        result = universalDcl;
        
    }; // constructor
    
    
    public AType getType ( ) {
        
        return result;
        
    }; // getType
    
    
    public void parse ( ) {
        
        Factor   aFactor; // a factor
        MultiplyingOp aMulOp;  // a multiplying operator
        AType   leftOpnd; // type of left operand
        
        while ( true ) {
            aFactor = new Factor(...);
            aFactor.parse();
            leftOpnd = result;
            result = aFactor.getType();
            if ( ! leftOpnd.equals(result) ) {
                semanticError("Incompatible types");
                result = universalDcl;
            };
            check(...);
        if ( tokenIn(...except(MultiplyingOp.STARTS)) ) break;
            if ( ! (result.equals(typeInt) | result.equals(typeFloat)) ) {
                semanticError("Wrong type for expression");
                result = universalDcl;
            };
            if ( tokenIn(MultiplyingOp.STARTS) ) {
                aMulOp = new MultiplyingOp(...);
                aMulOp.parse();
            };
        };
        
    }; // parse
    
    
} // Term