package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;


/** This class is the supertype of declarations that define types.    */

public abstract class Types extends Declarations implements AType {
    
    
    public Types ( String id ) {
        
        super(id);
        
    }; // constructor
    
    
    /** This method returns true if this and o are the same type.
      **
      ** @param o the other object
      **
      ** @return boolean this and o are the same type.    */
    
    public boolean equals ( Object o ) {
        
        if      ( o == null ) {
            return false;        // no o
        }
        else if ( o instanceof Universals ) {   // universal objects equal everything
            return true;
        }
        else if ( o.getClass() != this.getClass() ) { // must be same kind of type
            return false;
        }
        else {
            return this == o;       // the same object
        }
        
    }; // equals
    
    
    /** This method returns true if t is assignment compatible to this.
      **
      ** @param t the other type
      **
      ** @return boolean t is assignment compatible to this.   */
    
    public boolean compatibleWith ( AType t ) {
        
        return this.equals(t);     // compatible with equal type
        
    }; // compatibleWith
    
    
} // Types