package CompilerProj.Semantic;

import static CompilerProj.Compiler.*;


/** This class represents a name that is undeclared and hence of universal class. */

public class Universals extends Declarations implements AVariable, AConstructor, AMethod,
    AType, AClass, AnArray, Scope {
    
    
    public Universals ( String id ) {...}; // constructor
    
    
    public boolean equals ( Object o ) {...};   // AType - equals everything
        

    public boolean compatibleWith ( AType t ) {...};  // AType - compatible with everything
            
    
    public AClass getSuperclass ( ) {...};    // Scope - has no superclass
    
    
    public ADeclaration find ( String id ) {...};  // Scope - all ids defined
    
    
    public boolean alreadyDefined ( String id ) {...};  // Scope - nothing already defined
    
    
    public void define ( ADeclaration dcl ) {...};  // Scope - doesn't define
    
    
    public AConstructor getConstructor ( ) {...};  // AClass - universal
    
    
    public void setConstructor ( AConstructor c ) {...}; // AClass - doesn't set
    
    
    public boolean isFunction ( ) {...};     // AMethod - is a function
    
    
    public boolean isProcedure ( ) {...};    // AMethod - is a procedure
    
    
    public Parameters getParamList ( ) {...};   // AMethod - dummy paraemter list
    
    
    public AType getResult ( ) {...};     // AMethod - universal
    
    
    public boolean sigMatch ( AMethod meth ) {...};  // AMethod - match everything
    
    
    public AType getType ( ) {...};      // AVariable - universal
    
    
    public AType getEltType ( ) {...};     // AnArray - universal
    
    
    public String toString ( ) {...}; // toString
    
    
} // Universals