package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** var-dcl = type identifier         */

public class VarDcl extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...
    
    
    private AVariable decl;  // the variable declared
    
    
    public VarDcl ( Scope c, TokenSet s ) {
        
        super(c,s);
        decl = null;
        
    }; // constructor
    
    
    public AVariable getDecl ( ) {
        
        return decl;
        
    }; // getDecl
    
    
    public void parse ( ) {
        
        Type aType;  // the type
        String id;   // variable id
        
        aType = new Type(scope,...);
        aType.parse();
        id = expectId("Variable name expected",...);
        decl = new Declarations(id);
        
    }; // parse
    
    
} // VarDcl